#! /usr/bin/python
# code modified, tweaked and tailored from code by bertwert 
# on RPi forum thread topic 91796
import RPi.GPIO as GPIO
import time

#Define numbering system for the IO pins Raspberry Pi
GPIO.setmode(GPIO.BCM)
 
# Define GPIO ports for the 7seg
gpioSegments =  (5,6,13,19,26,21,20,16)
# 7seg_segment_pins (11,7,4,2,1,10,5,3) +  100R inline
# Setup channels for output and set initial values
for segment in (gpioSegments):
  GPIO.setup(segment,GPIO.OUT)
  GPIO.output(segment,GPIO.HIGH)
          
# Define GPIO ports for the digits 0-3
gpioDigits = (18,23,24,25)
# Pins (12,9,8,6) select digits 0-3 respectively reading LTR on display
# Setup channels for output and set initial values
for digit in (gpioDigits):
  GPIO.setup(digit,GPIO.OUT)
  GPIO.output(digit,GPIO.LOW)

#Define flags for comtrol of Colon separator on display
colon_visible=True
colon_counter=0

#Define segment arrays for each number to be displayed
numbers = {
	'0':(0,0,1,0,1,0,0,0),
    '1':(1,1,1,0,1,0,1,1), 
    '2':(0,0,1,1,0,0,1,0), 
    '3':(1,0,1,0,0,0,1,0), 
    '4':(1,1,1,0,0,0,0,1), 
    '5':(1,0,1,0,0,1,0,0), 
    '6':(0,0,1,0,0,1,0,0), 
    '7':(1,1,1,0,1,0,1,0), 
    '8':(0,0,1,0,0,0,0,0), 
    '9':(1,0,1,0,0,0,0,0), 
    ' ':(0,0,0,0,0,0,0,0)}

#Cycle through each digit and its segments  
try:
    while True:
        n = time.ctime()[11:13]+time.ctime()[14:16]
        s = str(n).rjust(4)

        for digit in range(4):
            GPIO.output(gpioDigits[digit], 1)
            for segment in range(0,8):         
                GPIO.output(gpioSegments[segment], numbers[s[digit]][segment]) 
                if ((digit==1) and (segment==2)):
					if (colon_counter<=50):
						if colon_visible==True:
							GPIO.output(13, 0)
						else:
							GPIO.output(13, 1)
					else:
						colon_counter = 0
						colon_visible =  not colon_visible
            time.sleep(0.005)
            
            for segment in (gpioSegments):
                GPIO.output(segment,GPIO.HIGH)
                
            for digit in (gpioDigits):
                GPIO.output(digit,GPIO.LOW)

        colon_counter=colon_counter+1
finally:
  gpio.cleanup()